<!DOCTYPE html>
<html>

	<head>
		<title>MapEC</title>
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<link rel="stylesheet" href="assets/css/main.css" /> 
		<link rel="stylesheet" href="assets/css/mapa.css" />
                <link href="//netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
                <link href='https://api.mapbox.com/mapbox-gl-js/v1.12.0/mapbox-gl.css' rel='stylesheet' />

		<!-- Scripts -->
			<script src="assets/js/jquery.min.js"></script>
			<script src="assets/js/jquery.scrolly.min.js"></script>
			<script src="assets/js/skel.min.js"></script>
			<script src="assets/js/util.js"></script>
			<script src="assets/js/main.js"></script>
                        <script src='https://api.mapbox.com/mapbox-gl-js/v1.12.0/mapbox-gl.js'></script>
                        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.0/jquery.min.js"></script>
                        <script src='https://npmcdn.com/csv2geojson@latest/csv2geojson.js'></script>
                        <script src='https://npmcdn.com/@turf/turf/turf.min.js'></script>
	</head>

	<body>
    <style>
      .filter-ctrl {
        position: absolute;
        top: 100px;
        right: 10px;
        z-index: 1;
      }
       
      .filter-ctrl input[type='text'] {
        font: 12px/20px 'Helvetica Neue', Arial, Helvetica, sans-serif;
        width: 100%;
        border: 0;
        background-color: #ffff;
        margin: 0;
        color: rgba(0, 0, 0, 0.5);
        padding: 10px;
        box-shadow: 0 0 0 2px rgba(0, 0, 0, 0.1);
        border-radius: 3px;
        width: 150px;
      }
      .filter-group {
        font: 12px/20px 'Helvetica Neue', Arial, Helvetica, sans-serif;
        font-weight: 600;
        position: absolute;
        top: 150px;
        right: 10px;
        z-index: 1;
        border-radius: 3px;
        width: 150px;
        color: #fff;
      }
      
      .filter-group input[type='checkbox']:first-child + label {
        border-radius: 3px 3px 0 0;
      }
      
      .filter-group label:last-child {
        border-radius: 0 0 3px 3px;
        border: none;
      }
      
      .filter-group input[type='checkbox'] {
        display: none;
      }
      
      .filter-group input[type='checkbox'] + label {
        background-color: #3386c0;
        display: block;
        cursor: pointer;
        padding: 5px;
        border-bottom: 1px solid rgba(0, 0, 0, 0.25);
      }
      
      .filter-group input[type='checkbox'] + label {
        background-color: #3386c0;
        text-transform: capitalize;
      }
      
      .filter-group input[type='checkbox'] + label:hover,
      .filter-group input[type='checkbox']:checked + label {
        background-color: #4ea0da;
      }
      
      .filter-group input[type='checkbox']:checked + label:before {
        content: '✔';
        margin-right: 5px;
      }
    </style>
		<!-- Header -->
			<header id="header">
				<a href="index.html" class="logo">Mapa <strong>de espacios culturales</strong></a>

				<nav>
					<a href="#menu">Menu</a>
				</nav>
			</header>

		<!-- Nav -->
			<nav id="menu">
				<ul class="links">
					<li><a href="index.html">Principal</a></li>
					<li><a href="proyecto.html">El proyecto</a></li>
					<li><a href="mapear.html">Mapear un espacio</a></li>
					<li><a href="mapa.html">Ver mapa</a></li>

				</ul>
			</nav>

  <div id='map'></div>

  <div class="filter-ctrl">
    <input id="filter-input" type="text" name="filter" placeholder="Filtrar por nombre">
  </div>

  <nav id="filter-group" class="filter-group"></nav>

  <script>

    var transformRequest = (url, resourceType) => {
      var isMapboxRequest =
        url.slice(8, 22) === "api.mapbox.com" ||
        url.slice(10, 26) === "tiles.mapbox.com";
      return {
        url: isMapboxRequest
          ? url.replace("?", "?pluginName=sheetMapper&")
          : url
      };
    };
    //YOUR TURN: add your Mapbox token 
    mapboxgl.accessToken = 'pk.eyJ1IjoiY3R5bmlrIiwiYSI6ImNrYzVnYWhteTA0emgyenFlbm5wcTdycHQifQ.ZGev0i_HerXEBNzYsYo9ag'; //Mapbox token 
    var map = new mapboxgl.Map({
      container: 'map', // container id
      style: 'mapbox://styles/mapbox/light-v10', //stylesheet location
      center: [-37.3282887, -59.1356957], // starting position
      zoom: 2,// starting zoom
      transformRequest: transformRequest
 
    });

    $(document).ready(function () {
      $.ajax({
        type: "GET",
        //YOUR TURN: Replace with csv export link
        url: 'https://docs.google.com/spreadsheets/d/1UJItpDiPunYltWlWqwzFxSQcr86vDrH01E0f-tBJouU/gviz/tq?tqx=out:csv&sheet=Espacios',
        dataType: "text",
        success: function (csvData) { makeGeoJSON(csvData); }
      });

      function makeGeoJSON(csvData) {
        csv2geojson.csv2geojson(csvData, {
          latfield: 'Latitud',
          lonfield: 'Longitud',
          delimiter: ','
        }, function (err, data) {

          const filterInput = document.getElementById('filter-input'); 
          const filterGroup = document.getElementById('filter-group');

          activities = new Map();
          
          // Assign each activity places to an activity key
          for (const feature of data.features) {
            const activityTypes = feature.properties.Actividad.split(','); // Assuming activities are separated by commas
            for (const activityType of activityTypes) {
              const trimmedActivityType = activityType.trim(); // Trim spaces
              if(trimmedActivityType != ""){
                if (!activities.has(trimmedActivityType)) {
                  activities.set(trimmedActivityType, []);
                }
                activities.get(trimmedActivityType).push(feature.properties.Nombre);
              }
            }
          }

          // Those places that allows every cultural expression have to be assigned to every key of the activities map
          for (const [key, value] of activities.entries()) {
            if (key !== "Apto Para toda expresión cultural") {
              activities.get(key).push(activities.get("Apto Para toda expresión cultural"));
            }
          }
          activities.delete("Apto Para toda expresión cultural");

          // Create and initialize checkboxes
          const keysArray = Array.from(activities.keys());
          for (const key of keysArray) {
            input = document.createElement('input');
            input.type = 'checkbox';
            input.id = key;
            input.checked = false;
            filterGroup.appendChild(input);
            const label = document.createElement('label');
            label.setAttribute('for', key);
            label.textContent = key;
            filterGroup.appendChild(label);

            // When the checkbox changes, update the visibility of the layers.
            input.addEventListener('change', (e) => {

              // Handles the visibility behavior of checkboxes and corresponding map layers
              if(e.target.checked){
                const checkboxes = document.querySelectorAll('.filter-group input[type="checkbox"]');
                checkboxes.forEach(checkbox => {
                  if((checkbox != e.target))
                    if((!checkbox.checked)){
                      for(const layer of activities.get(checkbox.id)){
                        map.setLayoutProperty(layer, 'visibility', 'none');
                      }
                    }else {
                      checkbox.checked = false;
                      for(const layer of activities.get(checkbox.id)){
                        map.setLayoutProperty(layer, 'visibility', 'none');
                      }
                    }
                    
                });
                // Updates visibility of the checkbox target of the event
                for(const layer of activities.get(key)){
                  map.setLayoutProperty(
                      layer,
                      'visibility',
                      e.target.checked ? 'visible' : 'none'
                  );
                }
              } else { // If the checkbox is unchecked, update all layers visibility to visible
                const places = activities.values();
                for (const placesArray of places){
                  for(const value of placesArray){
                      const stringValue = Array.isArray(value) ? value[0] : value;
                      map.setLayoutProperty(stringValue, 'visibility', 'visible');
                  }
                }
              }
              // Reset text filter if we're filtering by a checkbox 
              filterInput.value = "";
              
              // Update cluster data based on the visibility of individual layers
              const visibleFeatures = data.features.filter(feature => {
                const name = feature.properties.Nombre;
                return map.getLayoutProperty(name, 'visibility') === 'visible';
              });
              const clusterData = turf.featureCollection(visibleFeatures);
              map.getSource('espacios-culturales').setData(clusterData);
            });
          }

          map.on('load', function () {

            map.addSource('espacios-culturales', {
              type: 'geojson',
              data: data,
              cluster: true,
              clusterMaxZoom: 14,
              clusterRadius: 50
            });
            
            for (const feature of data.features) {
              const layerId = feature.properties.Nombre;
              const layerIdAct = feature.properties.Actividad;
              if (!map.getLayer(layerId)) {
                map.addLayer({
                        'id': layerId,
                        'type': 'circle',
                        'source': 'espacios-culturales',
                        'paint': {
                          'circle-color': "blue",
                          'circle-radius': 8,
                          'circle-stroke-color': '#8dd3c7',
                          'circle-stroke-width': 1
                        },
                        'filter': ['==', 'Nombre', layerId],
                        'layout': {
                          'visibility': 'visible'
                        }
                      });
              };
              
              map.on('click', layerId, function (e) {
                var coordinates = e.features[0].geometry.coordinates.slice();
                //set popup text 
                //You can adjust the values of the popup to match the headers of your CSV. 
                // For example: e.features[0].properties.Name is retrieving information from the field Name in the original CSV. 
                var description = `<h3>` + e.features[0].properties.Nombre + `</h3>` + '<h4>' + '<b>' + 'Dirección: ' + '</b>' + e.features[0].properties.Dirección + '</h4>' + '<h4>' + '<b>' + 'Localidad: ' + '</b>' + e.features[0].properties.Ciudad + '</h4>' + '<h4>' + '<b>' + 'Teléfono: ' + '</b>' + e.features[0].properties.Teléfono + '</h4>'  + '<br>' + '<h2>' + '<center>' + '<b>' + '<a href="' + e.features[0].properties.Redes + '" target="_blank" ><i class="fa fa-external-link" aria-hidden="true"></i></a>' +'  ' +'<a href="mailto:' + e.features[0].properties.Mail + '"><i class="fa fa-envelope-o" aria-hidden="true"></i></a>' + '</b>' + '</h2>' + '</center>';

                // Ensure that if the map is zoomed out such that multiple
                // copies of the feature are visible, the popup appears
                // over the copy being pointed to.
                while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                  coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
                }

                //add Popup to map
                new mapboxgl.Popup()
                  .setLngLat(coordinates)
                  .setHTML(description)
                  .addTo(map);
                });
			  
			    // Change the cursor to a pointer when the mouse is over the places layer.
				map.on('mouseenter', layerId, function () {
				  map.getCanvas().style.cursor = 'pointer';
			    });

				// Change it back to a pointer when it leaves.
				map.on('mouseleave', layerId, function () {
				  map.getCanvas().style.cursor = '';
				});
            }
            
            map.addLayer({
              id: 'clusters',
              type: 'circle',
              source: 'espacios-culturales',
              filter: ['has', 'point_count'],
              paint: {
                'circle-color': [
                  'step',
                  ['get', 'point_count'],
                  '#6699e6',
                  3,
                  '#6680e6',
                  5,
                  '#6666e6'
                ],
                'circle-radius': [
                  'step',
                  ['get', 'point_count'],
                  25,
                  3,
                  25,
                  5,
                  25
                ],
                'circle-stroke-color': [
                  'step',
                  ['get', 'point_count'],
                  '#476ba1',
                  3,
                  '#4759a1',
                  5,
                  '#4747a1'

                ],
                'circle-stroke-width': 3
              }
          });

            map.addLayer({
              id: 'cluster-count',
              type: 'symbol',
              source: 'espacios-culturales',
              filter: ['all', ['has', 'point_count'], ['!=', 'point_count', 1]],
              layout: {
                'text-field': ['get', 'point_count_abbreviated'],
                'text-font': ['DIN Offc Pro Medium', 'Arial Unicode MS Bold'],
                'text-size': 12
                },
 	      paint: {
    		'text-color': '#ffffff'
              }
            });

            // disable map rotation using right click + drag
            map.dragRotate.disable();
      
            // disable map rotation using touch rotation gesture
            map.touchZoomRotate.disableRotation();
          
            // Add zoom and rotation controls to the map.
            map.addControl(new mapboxgl.NavigationControl(), 'top-left');

            map.addLayer({
              'id': 'cantidades',
              'type': 'symbol',
              'source': 'espacios-culturales',
              'layout': {
              'text-field': [
                'match',
                ['get', 'Actividad principal'],
                'Biblioteca',
                'B',
                'Centro Cultural',
                'CC',
                'Teatro',
                'T',
                'Danza',
                'D',
                'Música',
                'M',
                'Multiespacio',
                'ME',
                'Sala de exposiciones',
                'SE',
                'Ferias',
                'F',
                /* otros */ ' '
              ],		
              'text-font': [
              'Open Sans Bold',
              'Arial Unicode MS Bold'
              ],
              'text-size': 14
              },
              'minzoom': 12,
              'paint': {
              'text-color': 'white'
              }
            });
            // inspect a cluster on click
            map.on('click', 'clusters', (e) => {
              const features = map.queryRenderedFeatures(e.point, {
                layers: ['clusters']
              });
              const clusterId = features[0].properties.cluster_id;
              map.getSource('espacios-culturales').getClusterExpansionZoom(
              clusterId,
              (err, zoom) => {
                if (err) return;     
                map.easeTo({
                  center: features[0].geometry.coordinates,
                  zoom: zoom
                });
              }
              );
            });

            // When a click event occurs on a feature in the csvData layer, open a popup at the
            // location of the feature, with description HTML from its properties.

            // Change the cursor to a pointer when the mouse is over the clusters layer.
             map.on('mouseenter', 'clusters', function () {
             map.getCanvas().style.cursor = 'pointer';
            });

            // Change it back to a pointer when it leaves.
            map.on('mouseleave', 'clusters', function () {
              map.getCanvas().style.cursor = '';
            });

            var bbox = turf.bbox(data);
            map.fitBounds(bbox, { padding: 50 });

            
            filterInput.addEventListener('keyup', (e) => {
              // If the input value matches the name of a map layer, update its visibility
              const inputValue = e.target.value.trim().toLowerCase();
              const places = activities.values();
              for (const placesArray of places){
                for(const value of placesArray){
                    const stringValue = Array.isArray(value) ? value[0] : value;
                    map.setLayoutProperty(
                        stringValue,
                        'visibility',
                        stringValue.toLowerCase().includes(inputValue) ? 'visible' : 'none'
                    );
                }
              }
              
              // Update cluster data based on the visibility of individual layers
              const visibleFeatures = data.features.filter(feature => {
                  const name = feature.properties.Nombre;
                  return map.getLayoutProperty(name, 'visibility') === 'visible';
              });
              const clusterData = turf.featureCollection(visibleFeatures);
              map.getSource('espacios-culturales').setData(clusterData);
            });
            
          });
        });
      };
   });
 </script>


</body>

</html>
